import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core/ES5/type";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core/ES5/IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core/ES5/Brush";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { Dictionary$2 } from "igniteui-react-core/ES5/Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core/ES5/FastItemsSourceEventAction";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    im(a: SeriesView): void;
    mh: FinancialSeriesView;
    protected get_cr(): boolean;
    ag(): Axis[];
    protected n1(): number;
    private nz;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    o7: Brush;
    k2(): Brush;
    hn(): void;
    l1: CategoryAxisBase;
    mm: NumericYAxis;
    oh: string;
    mv: IFastItemColumn$1<number>;
    private mu;
    n8: string;
    mr: IFastItemColumn$1<number>;
    private mq;
    od: string;
    mt: IFastItemColumn$1<number>;
    private ms;
    n5: string;
    mp: IFastItemColumn$1<number>;
    private mo;
    ol: string;
    my: IFastItemColumn$1<number>;
    private mx;
    m7: boolean;
    protected m1: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    protected m9(): boolean;
    protected ot(a: AssigningCategoryStyleEventArgs): void;
    protected l9: CategorySeriesRenderManager;
    protected or(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    nr(a: Point): number;
    fb(a: Point, b: boolean): number;
    e9(a: Point, b: boolean): number;
    d6(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    le(a: Point, b: boolean, c: boolean): Point;
    ek(a: Point, b: boolean, c: boolean): number;
    eg(a: Point, b: boolean, c: boolean): number;
    ei(a: Point, b: boolean, c: boolean): number;
    nt(a: Point, b: boolean, c: boolean): number;
    nu(a: Point, b: boolean, c: boolean): number;
    nv(a: Point, b: boolean, c: boolean): number;
    la(a: Point, b: boolean, c: boolean): Point;
    lc(a: Point, b: boolean, c: boolean): Point;
    o9(a: Point, b: boolean, c: boolean): Point;
    o8(a: Point, b: boolean, c: boolean): Point;
    pa(a: Point, b: boolean, c: boolean): Point;
    h4(): void;
    protected jm(a: Rect, b: Rect): void;
    protected jl(a: Rect, b: Rect): void;
    protected nc: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected nd: Dictionary$2<string, string>;
    private mw;
    private oq;
    private m0;
    protected is(a: any, b: string, c: any, d: any): void;
    m3(a: any): boolean;
    m2(a: any): boolean;
    protected lu(a: number, b: number, c: Axis): any[];
    protected ny(a: SeriesView): number;
    protected n0(a: SeriesView): number;
    lt(a: number, b: number): any[];
    private mk;
    protected get_m5(): boolean;
    protected readonly m5: boolean;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    n2(a: Point): number;
    protected mj(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mi(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected m4(): boolean;
    d8(a: Point): number;
    e5(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    e7(a: Point): number;
    fm(a: Point): any;
    l4: CategoryFrame;
    l6: CategoryFrame;
    l3: CategoryFrame;
    protected ns(a: Rect, b: Rect, c: Rect): number;
    mb: CategoryTransitionInMode;
    m8: boolean;
    protected db(): boolean;
    protected ma(): CategoryTransitionInMode;
    protected bo(): TransitionInSpeedType;
    ou(a: CategoryFrame, b: FinancialSeriesView): void;
    os(a: CategoryFrame, b: FinancialSeriesView): void;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    mc: CategoryTransitionSourceFramePreparer;
    nw(a: FinancialSeriesView): number;
    protected hq(): void;
    i7(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected na(a: IList$1<string>): boolean;
    readonly nb: boolean;
    protected m6(): boolean;
    protected op(a: FinancialEventArgs): void;
    protected readonly nj: IEnumerable$1<number>;
    private _ng;
    private ng;
    protected readonly ni: IEnumerable$1<number>;
    private _nf;
    private nf;
    protected readonly nh: IEnumerable$1<number>;
    private _ne;
    private ne;
    nl(a: IList$1<number>): IList$1<number>;
    private mz;
    protected nk(): IList$1<string>;
    private np;
    getOpenColumnAsArray(): number[];
    private nn;
    getHighColumnAsArray(): number[];
    private no;
    getLowColumnAsArray(): number[];
    private nm;
    getCloseColumnAsArray(): number[];
    private nq;
    getVolumeColumnAsArray(): number[];
    protected hs(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected md(a: number, b: number): FinancialCalculationDataSource;
    nx(a: number): number;
    protected me(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private l5;
    i8(a: Rect, b: RenderSurface): void;
    private l2;
    i5(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    am(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private l7;
    l8: CategoryMode;
    protected get_cz(): boolean;
    jb(a: Brush, b: Brush): void;
    private ov;
    private ml;
    private mn;
    fo(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bw: FinancialSeries;
    bu: FinancialBucketCalculator;
    by: number;
    bx(a: CategoryFrame): boolean;
    bz(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract bv(): FinancialBucketCalculator;
    ap(): void;
    getDefaultTooltipTemplate(): string;
    protected ac(): void;
}
